// The functions contained in this file are pretty dummy
// and are included only as a placeholder. Nevertheless,
// they *will* get included in the shared library if you
// don't remove them :)
//
// Obviously, you 'll have to write yourself the super-duper
// functions to include in the resulting library...
// Also, it's not necessary to write every function in this file.
// Feel free to add more files in this project. They will be
// included in the resulting library.

#include "ACapture.h"
 


int Capture_test(void*api, int vidx, int aidx)
{
	if (api)
	{
		DEV_NAME vdev[50]; int nb_vdev = 50;
		DEV_NAME adev[50]; int nb_adev = 50;
		CA_GetCaptureDevices(api,vdev,&nb_vdev,adev,&nb_adev);

		if (vidx >= nb_vdev)
		{
			printf("no found video capture device by index %d\n",vidx);
			return -1;
		}
		if (aidx >= nb_adev)
		{
			printf("no found audio capture device by index %d\n",aidx);
			return -1;
		}

		DEV_NAME dev = vdev[vidx];
		DEV_NAME aev = adev[aidx];

		DEV_CAPACITY cap[30];
		int nb_cap = 30;
		DEV_CAPACITY curr;
		CA_GetCaptureDeviceCapacity(api,&dev, cap, &nb_cap, &curr);
		printf("video capture capacity list:\n");
		for (int i = 0; i< nb_cap; i++)
		{
			printf("\t[%d] %dx%d@%dfps [%s]\n",i,cap[i].width,cap[i].height,(int)cap[i].fps,cap[i].codec_name);
		}

		int ret = CA_OpenDevice(api,1,1,&dev,&curr,&aev); //4,11   21
		if (ret==1)
		{
			printf("Press enter key to record 15 seconds 1080P@30fps mp4 file(./record.mp4).\n");

			getchar();
			CA_StartRecord(api,"./record.mp4",1920,1080,30,10*1024*1024);
			int sec = 15;
			while((sec--)>=0)
			{
				usleep(1000*1000);
				const char*info =CA_GetDebugInfo(api);
				printf("%s\n",info);
			}
			CA_StopRecord(api);

			printf("Press enter key to exit.\n");
			getchar();
			CA_CloseDevice(api);
		}
		else
			printf("Open capture device failed.\n");
	}

	return 0;
}
void usage()
{
	printf("Usage:\n");
	printf("-l   list all capture devices\n");
	printf("-c <video device index> <audio device index>  capture a test mp4.\n");
}
int main(int arc,const char*argv[])
{
 
   if (arc  == 2)
   {
	   if (!strcmp(argv[1],"-l"))
	   {
           void *api =0;
           CA_Initalize(&api,NULL,"prod");
		   printf("Searching capture devices ...\n");
		   DEV_NAME vdev[50]; int nb_vdev = 50;
		   DEV_NAME adev[50]; int nb_adev = 50;
		   if (CA_GetCaptureDevices(api,vdev,&nb_vdev,adev,&nb_adev))
		   {
			   printf("Search capture device success.\n");
			   printf("Video device: %d\n",nb_vdev);
			   for (int i = 0; i < nb_vdev; i++)
				   printf("\t[%d] %s(%s)\n",i,vdev[i].dev_name,vdev[i].dev_path);
			   printf("Audio device: %d\n",nb_adev);
			   for (int i = 0; i < nb_adev; i++)
				   printf("\t[%d] %s(%s)\n",i,adev[i].dev_name,adev[i].dev_path);
		   }
		   else
			   printf("Search capture device failed.\n");
            CA_Release(&api);
	   }
	   else
		   usage();
   }
   else if (arc == 4)
   {
	   if (!strcmp(argv[1],"-c"))
	   {
           void *api =0;
           CA_Initalize(&api,NULL,"prod");
		   int vidx = atoi(argv[2]);
		   int aidx = atoi(argv[3]);
		   Capture_test(api,vidx,aidx);
		   CA_Release(&api);
	   }
	   else
		   usage();
   }
   else
	   usage();


   return 0;
}
